unit MainPQ;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  PriorityQueue, StdCtrls;

type

  { TMainForm }

  TMainForm = class(TForm)
    SepEdit: TEdit;
    InsertButton: TButton;
    ClearButton: TButton;
    SepLabel: TLabel;
    ListEdit: TEdit;
    InsertEdit: TEdit;
    ListLabel: TLabel;
    RecursiveCheckBox: TCheckBox;
    procedure ClearButtonClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure InsertEditChange(Sender: TObject);
    procedure RecursiveCheckBoxChange(Sender: TObject);
    procedure SepEditChange(Sender: TObject);
  private
    { private declarations }
    FList: TSortedIntList;
  public
    { public declarations }
    procedure UpdateViews;
  end; 

var
  MainForm: TMainForm;

implementation

{ TMainForm }

procedure TMainForm.ClearButtonClick(Sender: TObject);
begin
  DisposeList ( FList );
  FList := nil;
  UpdateViews;
end;

procedure TMainForm.InsertButtonClick(Sender: TObject);
var
  v: Integer; // value to be inserted
begin
  {@ TryStrToInt(InsertEdit.Text, x) }
  v := StrToInt ( InsertEdit.Text );
  if RecursiveCheckBox.Checked
  then InsertListR ( FList, v )
  else InsertListI ( FList, v );
  UpdateViews;
end;

procedure TMainForm.InsertEditChange(Sender: TObject);
var
  dummy: Integer; // to capture result of TryStrToInt
begin
  InsertButton.Enabled := TryStrToInt ( InsertEdit.Text, dummy );
end;

procedure TMainForm.RecursiveCheckBoxChange(Sender: TObject);
begin
  UpdateViews;
end;

procedure TMainForm.SepEditChange(Sender: TObject);
begin
  UpdateViews;
end;

procedure TMainForm.UpdateViews;
begin
  if RecursiveCheckBox.Checked
  then ListEdit.Text := ListToStrR ( FList, SepEdit.Text )
  else ListEdit.Text := ListToStrI ( FList, SepEdit.Text )
end;

initialization
  {$I mainpq.lrs}

end.

