unit PriorityQueue;
  { (c) 2009, Tom Verhoeff (SET @ TU/e) }

// Please do not remove the BEGIN-END TODO markers

//# BEGIN TODO Completed by: author name, id.nr., date (for unit header)
  Replace this line by your text.
//# END TODO

interface

  //----------------------------------------------------------------------------
  //  Class TPrioQueueOfInt implements an unbounded priority queue of integers
  //  using a single-linked list with pointers.
  //----------------------------------------------------------------------------

type
  PCell = ^TCell; // pointer to a TCell
  TCell = record
    FVal: Integer; // stored value
    FNext: PCell; // nil or pointer to next cell
  end;
  { for p, q: PCell, we write p -> q whenever p^.FNext = q }

  TIntList = PCell; // list of integer values
    { extra data invariant: for s of type TIntList we have that
      s leads to nil in a finite number of -> steps (possibly zero).
      Define list(s) = [] (empty list) if s = nil, and otherwise
      list.s = [ s^.FVal ] ++ list(s^.FNext) }

  TSortedIntList = TIntList; // sorted list of integer values
    { extra data invariant: for s of type TSortedIntList we have
      the values in list(s) are sorted in ascending order. }

function ListToStrI ( s: TIntList; sep: String ): String;
function ListToStrR ( s: TIntList; sep: String ): String;
  { pre: True
    ret: list(s) as string with the first value preceded by sep
         and each of the remaining values by a single space. }
  { N.B. ListToStr ( nil, ' ' ) = '' (empty string) }

procedure InsertListI ( var s: TSortedIntList; v: Integer );
procedure InsertListR ( var s: TSortedIntList; v: Integer );
  { pre: True
    post: list(s) = sorted(list(old s) ++ [ v ]), where
      sorted(x) = values of list x in ascending order }

procedure DisposeList ( var s: TIntList );
  { pre: True
    post: all cells in s have been disposed }

type
  TPrioQueueOfInt =
  class(TObject)
  private
    FList: TSortedIntList; // the list of values
    // further details irrelevant for this assignment
  end;

implementation //===============================================================

uses
  SysUtils; // for IntToStr

function MakeCell ( v: Integer; p: PCell ): PCell;
  { pre: True
    ret: pointer to newly created TCell storing value v and p as next cell }
begin
  new(Result);
  Result^.FVal := v;
  Result^.FNext := p;
end;

function ListToStrI ( s: TIntList; sep: String ): String;
  { iterative implementation using a loop }
begin
//# BEGIN TODO body of ListToStrI
  Replace this line by your text.
//# END TODO 
end;

function ListToStrR ( s: TIntList; sep: String ): String;
  { recursive implementation without loop }
begin
//# BEGIN TODO body of ListToStrR
  Replace this line by your text.
//# END TODO 
end;

procedure InsertListI ( var s: TSortedIntList; v: Integer );
  { iterative implementation (using a loop) }
var
  p: PCell; // to traverse s
begin
//# BEGIN TODO body of InsertListI
  Replace this line by your text.
//# END TODO 
end;

procedure InsertListR ( var s: TSortedIntList; v: Integer );
  { recursive implementation without loop }
begin
//# BEGIN TODO body of InsertListR
  Replace this line by your text.
//# END TODO 
end;

procedure DisposeList ( var s: TIntList );
var
  p: PCell; { auxiliary pointer to cell to be disposed }
begin

  while s <> nil do begin
    p := s;
    s := s^.FNext;
    Dispose(p);
  end;

end;

end.
